package de.killig.qbist;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.Dialog;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.Window;
import android.view.WindowManager;

public class Qbist extends Activity /*implements OnGesturePerformedListener*/ {
  private static final String LOG_TAG = "Qbist";
	QbistView v;
	//private GestureLibrary mLibrary;
	
  static {
    System.loadLibrary("qbist");
  }

  @Override
  public void onCreate(Bundle savedInstanceState)
  {
    super.onCreate(savedInstanceState);
		Log.d(LOG_TAG, "onCreate()");
    requestWindowFeature(Window.FEATURE_NO_TITLE);
    getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);  
    /*DisplayMetrics metrics = new DisplayMetrics();
    getWindowManager().getDefaultDisplay().getMetrics(metrics);*/
    v=new QbistView(this);
    setContentView(v);
    /*setContentView(R.layout.main);
    v=(QbistView) findViewById(R.id.qbistview);*/
    /*mLibrary = GestureLibraries.fromRawResource(this, R.raw.gestures);
    if (!mLibrary.load()) {
        finish();
    }
    GestureOverlayView gestures = (GestureOverlayView) findViewById(R.id.gestures);
    gestures.addOnGesturePerformedListener(this);*/
  }
  
  /*@Override
  public void onConfigurationChanged(Configuration newConfig) {
  	super.onConfigurationChanged(newConfig);
		Log.d(LOG_TAG, "onConfigurationChanged()");
    if (newConfig.orientation == Configuration.ORIENTATION_LANDSCAPE) {
    	if(v.t!=null && v.t.isAlive()) {
    		v.t.interrupt();
    		try {
    			v.t.join();
  			} catch (InterruptedException e) {
  				e.printStackTrace();
  			}
    	}
    	v.init();
    }
  }*/
  
  /*@Override
  protected void onResume() {
  	super.onResume();
		Log.d(LOG_TAG, "onResume()");
  	v.onResume();
  }*/
  
  /*@Override
  public boolean onPrepareOptionsMenu(Menu menu) {
  	if(v.t!=null && v.t.isAlive()) {
  		//return false;
  		try {
  			v.t.join();
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
  	}
  	return super.onPrepareOptionsMenu(menu);
  }*/
  
  @Override
  protected Dialog onCreateDialog(int id) {
  	AlertDialog.Builder builder = new AlertDialog.Builder(this);
  	builder.setMessage("Variation coarseness dependent on vertical touch position within a patch.\n"+
  			"Written 2011 by Sven Killig.\n" +
  			"Based on an article by Dr. Jrn Loviscach (appeared in c't 10/1995, page 326). Thanks to Horst Klier for the idea and Daniel Tippmann for remembering the name. Optimizations by Host Klier and Jens Ch. Restemeier.\n"+
  			"Detected CPU cores: "+QbistView.AVAILABLE_PROCESSORS
  	);
  	return builder.create();
  }

  
  @Override
  public boolean onCreateOptionsMenu(Menu menu) {
    MenuInflater inflater = getMenuInflater();
    inflater.inflate(R.menu.menu, menu);
    return true;
  }

  @Override
  public boolean onOptionsItemSelected(MenuItem item) {
  	if(v.mtg!=null /*&& v.tg.isAlive()*/) {
  		//try {
  			v.mtg.join();
			/*} catch (InterruptedException e) {
				e.printStackTrace();
			}*/
  	}
    switch (item.getItemId()) {
    /*case R.id.fine:
    	QbistView.SwitchCoarseness((short)0);
      return true;
    case R.id.medium:
    	QbistView.SwitchCoarseness((short)1);
      return true;
    case R.id.coarse:
    	QbistView.SwitchCoarseness((short)2);
      return true;*/
    case R.id.randomize:
    	QbistView.OnNewDocument();
    	v.init();
      return true;
    case R.id.wallpaper:
    	v.save(true);
      return true;
    case R.id.save:
    	v.save(false);
      return true;
    case R.id.help:
    	showDialog(0);
      return true;
    default:
      return super.onOptionsItemSelected(item);
    }
  }

	/*@Override
	public void onGesturePerformed(GestureOverlayView overlay, Gesture gesture) {
		Log.d(LOG_TAG, "onGesturePerformed()");
    ArrayList<Prediction> predictions = mLibrary.recognize(gesture);
    if (predictions.size() > 0 && predictions.get(0).score > 1.0) {
    		Log.d(LOG_TAG, "onGesturePerformed()"+predictions.get(0).score);
        String action = predictions.get(0).name;
        Toast.makeText(this, action, Toast.LENGTH_SHORT).show();
        if ("action_add".equals(action)) {
            Toast.makeText(this, "Adding a contact", Toast.LENGTH_SHORT).show();
        } else if ("action_delete".equals(action)) {
            Toast.makeText(this, "Removing a contact", Toast.LENGTH_SHORT).show();
        } else if ("action_refresh".equals(action)) {
            Toast.makeText(this, "Reloading contacts", Toast.LENGTH_SHORT).show();
        }
    }
	}*/
}
